<template>
	<div>
		<v-snackbar v-model="snackbar" class="subtitle-1" top right color="#72a051">Registro exitoso</v-snackbar>
		<v-snackbar v-model="snackErr" class="subtitle-1" top right color="#c51f2f">{{msg}}</v-snackbar>
		<v-form ref="formNewAdmin" v-model="isValid">
			<v-dialog v-model="showDialog" persistent max-width="570">
				<v-card color="grey lighten-3">
					<v-card-title>Registro</v-card-title>
					<v-card-text>
						<v-row>
							<v-col cols="12" sm="6">
								<v-text-field
									id="curp"
									prepend-icon="fas fa-id-card"
									label="CURP"
									:rules="rulesCURP"
									outlined
									v-model="admin.curp"
									required
								/>
							</v-col>
							<v-col cols="12" sm="6">
								<v-text-field
									prepend-icon="fas fa-at"
									label="Correo electrónico"
									:rules="rulesEmail"
									outlined
									v-model="admin.email"
									required
								/>
							</v-col>
						</v-row>
						<v-row>
							<v-col cols="12" sm="6">
								<v-text-field
									prepend-icon="fas fa-key"
									label="Contraseña"
									:rules="rulesPass"
									outlined
									:append-icon="showPass ? 'fa-eye' : 'fa-eye-slash'"
									:type="showPass ? 'text' : 'password'"
									@click:append="showPass = !showPass"
									v-model="admin.pass"
									required
								/>
							</v-col>
							<v-col cols="12" sm="6">
								<v-text-field
									prepend-icon="fas fa-key"
									label="Confirmar contraseña"
									:rules="confirmPass"
									outlined
									:append-icon="showComparePass ? 'fa-eye' : 'fa-eye-slash'"
									:type="showComparePass ? 'text' : 'password'"
									@click:append="showComparePass = !showComparePass"
									v-model="comparePass"
									required
								/>
							</v-col>
						</v-row>
						<v-row>
							<v-col cols="12" sm="6">
								<v-btn :disabled="!isValid" rounded block color="success" @click="addAdmin(admin)">Registrar</v-btn>
							</v-col>
							<v-col cols="12" sm="6">
								<v-btn dark rounded block color="#c51f2f" @click="closeFormNewAdmin">Cancelar</v-btn>
							</v-col>
						</v-row>
					</v-card-text>
				</v-card>
			</v-dialog>
		</v-form>
	</div>
</template>

<script>
import EventBus from "../../bus";
import { mapActions } from "vuex";

export default {
	name: "FormNewAdmin",
	props: ["showDialog"],
	data: () => ({
		blockButton: false,
		snackbar: false,
		snackErr: false,
		msg: "",
		showPass: false,
		showComparePass: false,
		comparePass: "",
		isValid: true,
		admin: {
			curp: "",
			email: "",
			pass: ""
		},
		rulesPass: [
			value => !!value || "Campo requerido",
			value => (value || "").length >= 8 || "Mínimo 8 carácteres"
		],
		rulesCURP: [
			value => !!value || "Campo requerido",
			value =>
				(value || "").length === 18 || "18 carácteres obligatorios",
			value => {
				const patternName = /[`~!@#$%^&*()_°¬|+\-=?;:'",<>\{\}\[\]\\\/]/gi;
				return !patternName.test(value) || "Solo letras y números";
			}
		],
		rulesEmail: [
			value => !!value || "Campo requerido",
			value => {
				const pattern = /^\w+([\.-]?\w+)*@\w+(\.com||\.com\.mx||\.mx||\.es||\.gob\.mx)+$/;
				return pattern.test(value) || "Correo electrónico inválido";
			}
		]
	}),
	computed: {
		// Verifica ambas contraseñas sean correctas
		confirmPass() {
			return [
				this.admin.pass === this.comparePass ||
					"La contraseña no coincide"
			];
		}
	},
	watch: {
		// escucha el input curp y transforma el texto a mayusculas
		admin: {
			handler(val, oldVal) {
				if (this.admin.curp !== undefined) {
					this.admin.curp = this.admin.curp.toUpperCase();
				}
			},
			deep: true
		}
	},
	methods: {
		...mapActions(["addAdmin"]),

		// cierra el formulario
		closeFormNewAdmin() {
			this.$refs.formNewAdmin.reset();
			EventBus.$emit("closeFormNewAdmin");
		}
	},
	mounted() {
		// cierra el formulario de nuevo admin
		document.addEventListener("keydown", event => {
			const keyWhich = event.which;
			if (keyWhich == 27) {
				this.closeFormNewAdmin();
			}
		});

		EventBus.$on("responseNewAdmin", msg => {
			switch (msg) {
				case "CURP o correo existente":
					this.msg = msg;
					this.snackErr = true;
					setTimeout(() => {
						this.snackErr = false;
					}, 2000);
					break;
				default:
					this.isValid = false;
					this.snackbar = true;
					this.blockButton = true;
					setTimeout(() => {
						this.closeFormNewAdmin();
						this.snackbar = false;
					}, 2000);
					break;
			}
		});
	}
};
</script>

<style scope>
#curp {
	text-transform: uppercase;
}
</style>